//+------------------------------------------------------------------+
//|  LSdemarker_in_Color                                             |
//|  Perky               Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, FX Sniper "
#property  link      "http://www.metaquotes.net/"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property indicator_color1 Gray      
#property indicator_color2 Green
#property indicator_color3 Red
//#property indicator_minimum 0
//#property indicator_maximum 100

#property indicator_level1 20
#property indicator_levelcolor DarkSlateGray

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
int width;

extern int LRperiod = 5;
extern int ADXperiod = 14, plusDIperiod = 14, minusDIperiod = 14;
extern int ADXprice  = 0;
extern int BarProcessed = 1000;

int shift;
int i;
int loopbegin;
double sum[],sum1[],sum2[];
int length;
double lengthvar;
double tmp,tmp1,tmp2;
double wt[],wt1[],wt2[];
int c;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(8);
   
//---- drawing settings
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,sum);
   SetIndexBuffer(4,sum1);
   SetIndexBuffer(5,sum2);
   
   SetIndexStyle(0,DRAW_LINE);  
   SetIndexStyle(1,DRAW_LINE);  
   SetIndexStyle(2,DRAW_LINE);  

   IndicatorShortName("ADX "+ADXperiod+" (+DI: "+plusDIperiod+"; -DI: "+minusDIperiod+") LR "+LRperiod+" ");


//---- initialization done
   return(0);
  }

int start()
   {
   if (Bars < LRperiod+1)  BarProcessed = Bars-LRperiod-1;
	if (Bars < LRperiod+1)  return;
	if (BarProcessed ==0) BarProcessed = Bars-LRperiod-1;
	
   length = LRperiod;
   loopbegin = BarProcessed;
 
   for(shift = loopbegin; shift >= 0; shift--)
      {
      sum[1] = 0;sum1[1] = 0;sum2[1] = 0;
      for(i = length; i >= 1  ; i--)
         {
         lengthvar = length + 1;
         lengthvar /= 3;
         tmp = 0;  tmp1 = 0; tmp2 = 0;
        
         tmp  = ( i - lengthvar)*  iADX(NULL,0,ADXperiod,  ADXprice,MODE_MAIN, length-i+shift);
         sum [1]+=tmp;
         
         tmp1 = ( i - lengthvar)*  iADX(NULL,0,plusDIperiod,  ADXprice,MODE_PLUSDI,length-i+shift);
         sum1[1]+=tmp1;
                
         tmp2 = ( i - lengthvar)*  iADX(NULL,0,minusDIperiod,  ADXprice,MODE_MINUSDI,length-i+shift);
         sum2[1]+=tmp2;
                  

         }
         
   ExtMapBuffer1[shift]   = sum [1]*6/(length*(length+1));
   ExtMapBuffer2[shift]   = sum1[1]*6/(length*(length+1));
   ExtMapBuffer3[shift]   = sum2[1]*6/(length*(length+1));
     

      
        
      }    
      
      
      return(0);
   }